
#include<pic.h>


int direction , threashold ,  STEADY_X , NEW_X , AX , i , M , i_state , duty , dimming , glowing , m_state , period , LEFT , RIGHT ;




	i_state = 0 ;
	m_state = 0 ;


	
	void CHANGE_STATE();


	void STATE_ONE();

	void STATE_TWO();

	void STATE_THREE();

	void STATE_FOUR();

	void STATE_FIVE();

	void STATE_SIX();



	main()


	{

	for (	i = 0 ; i < 1000 ; i ++ ) ;
	




           PORTC = 0 ;

           PORTE = 0 ;


	
	threashold = 60	;		// THIS IS THE MOTION THREASHOLD VALUE ---> MY DEFAULT IS 60




	i = 0	;

	direction = 0 ;

	
	LEFT = 0 ;

	RIGHT = 0 ;




	LCDCON = 0X03 ;			//  THIS IS VERY IMPORTANT TO DISABLE LCD MODULE ON PINS RC0,1,2 AND RUN THE PINS NORMALLY	




	TRISA = 0xFF ;			// input
	TRISC = 0x00 ;			// output
	TRISE = 0x00 ;			// output

	ADRESH = 0x00 ;
	ADRESL = 0x00 ;



	RA0 = 0 ;

	NEW_X= 0x00 ;

	STEADY_X = 0x00 ;




	// ----------------------------------------	CONFIGURE ADC	---------------------------------------


//	ADCON0 = 0x85 ;				//    10000101		Right justified  , V ref+ = V dd  ,  Ch 1

	ADCON0 = 0x81 ;				//    10000001		Right justified  , V ref+ = V dd  ,  Ch 0

	ADCON1 = 0x30 ;


	




	ADCON0,GODONE = 1 ;			// ----- START ADC	---------------------------------------





wait_eoc_first   :    while ( ADCON0,GODONE != 0 )




	{
		goto wait_eoc_first   ;
	}





	STEADY_X = ( ADRESH * 256 ) + ADRESL ;		// THIS IS THE STEADY STATE ACCELERATION 0 g ------- > 2.5 VOLT


	





		for(;;)
			{







	i++;


	if ( i > 10  )

		{
			M++;

			i=0;

		}




	if ( M > 1500 )			// THIS IS THE RESPONSE OF NEXT ORDER TIME 

	{





	ADCON0,GODONE = 1 ;		// ----- START ADC	---------------------------------------



	wait_eoc   :    while ( ADCON0,GODONE != 0 )


		{

		goto wait_eoc   ;

		}



	AX = ( ADRESH * 256 ) + ADRESL ;		// THIS IS THE RESULTING X ACCELERATION FROM THE ACCELEROMETER

	NEW_X = AX ;












		if (        (     ( NEW_X - STEADY_X )     > threashold     )    ||    (     ( STEADY_X - NEW_X  )   > threashold   )         )
			

			{ 


						CHANGE_STATE()  ;


			}








	M = 0 ;


	}				// END OF               THIS IS THE RESPONSE OF NEXT ORDER TIME 




	if ( direction == 1 )	STATE_ONE();


	if ( direction == 2 )	STATE_TWO();


	if ( direction == 3 )	STATE_THREE();


	if ( direction == 4 )	STATE_FOUR();


	if ( direction == 5 )	STATE_FIVE();


	if ( direction == 6 )	STATE_SIX() ;


			}		// END OF for(;;)




				}		// END OF main()



 





void CHANGE_STATE()



{




		direction ++	;

		if ( direction == 7 ) direction = 1 ;


		if ( direction == 0 ) direction = 6 ;




//	direction = 6 ;					// test of states


	return ;
}


















//-------------------------------------------- STATES DECLARATION -------------------------------------------

// **********************************************************************************************************





//------------------------------------------- STATE_ONE	              DEFINITION -----------------------------------



	void STATE_ONE()			// STEADY PURPLE ( HIGH SPEED BLINKING )


{

	period = 255 ;

	duty 	= 128;

	i_state++;

		if (  i_state <= duty )		// DUTY = 128

			{
				PORTE = 0XFF ; 	//phase 1 HIGH 
				PORTC = 0XFF ; 	//phase 1 HIGH 
			}

			else 

			{
				PORTE = 0X00 ; 	//phase 1 LOW
				PORTC = 0X00 ; 	//phase 1 LOW
			}



	if ( i_state == period )	i_state = 0 ;



	return ;

}




//-------------------------------END OF		STATES_ONE ---------------------------------------------------------








//------------------------------------ STATE_TWO 	DEFINITION ---------------------------------------------



	void STATE_TWO()		// HEART BEAT (	VARIABLE DUTY )

{


	period = 255 ;

	//	duty is variable

	i_state ++ ;

		if (	i_state <= duty)

			{
				PORTE = 0XFF ; 	//phase 1 HIGH 
				PORTC = 0XFF ; 	//phase 1 HIGH 

			}

			else 

			{
				PORTE = 0X00 ; 	//phase 1 LOW
				PORTC = 0X00 ; 	//phase 1 LOW

			}







	if ( i_state >= period )

		{

	i_state = 0 ;	 		// Reset counter for phase



	m_state++;




	if ( m_state >	3 )

{
	m_state = 0 ;

	if( duty <= 0 )
	{

	duty = 0 ;

	dimming = 0 ;

	glowing=1;

	}

	if ( duty >= period )

	{

	duty = period ;

	dimming=1;

	glowing=0;

	}




	if (	glowing == 1	)
	
	{
				duty++ ; 	//increase duty
	}

	if (	dimming==1	)

	{
				duty-- ; 	//decrease duty
	}		

}



		
		}  // end of period machine
	

	return ;

}



//----------------------------------END OF STATE_TWO DEFINITION -----------------------------------------






//------------------------------------ STATE_THREE 	DEFINITION ---------------------------------------------


	void STATE_THREE()			//  BLINKING	@  0.25 Hz	PERIOD = 250 mS		DUTY = 0.5

{



	period = 5000 ;

	duty 	= 2500 ;

	i_state++;

		if (  i_state <= duty )

			{
				PORTE = 0XFF ; 	//phase 1 HIGH 
				PORTC = 0XFF ; 	//phase 1 HIGH 
			}

			else 

			{
				PORTE = 0X00 ; 	//phase 1 LOW
				PORTC = 0X00 ; 	//phase 1 LOW
			}



	if ( i_state == period )	i_state = 0 ;




	return ;


}

//----------------------------------END OF STATE_THREE DEFINITION -----------------------------------------





//------------------------------------ STATE_FOUR	DEFINITION ---------------------------------------------


	void STATE_FOUR()			//	INTERLEACE	@ 0.25 Hz ( R = ON & B = OFF ) OR ( R = OFF & B = ON )

{



	period = 10000 ;

	duty 	= 5000 ;

	i_state++;



		if (  i_state <= duty )

			{
				PORTE = 0XFF ;
				PORTC = 0X00 ;
			}

			else 

			{
				PORTE = 0X00 ;
				PORTC = 0XFF ;
			}


	if ( i_state == period )	i_state = 0 ;





	return ;

}

//----------------------------------END OF STATE_FOUR DEFINITION -----------------------------------------







//------------------------------------ STATE_FIVE	DEFINITION ---------------------------------------------


	void STATE_FIVE()			//	INTERLEACE	@ 0.25 Hz ( R = ON & B = OFF ) OR ( R = OFF & B = ON ) 
						//	DUTY = 0.25	RED	, DUTY = 0.75 BLUE 
{



	period = 5000 ;

	duty 	= 1250 ;

	i_state++;

		if (  i_state <= duty )

			{
				PORTE = 0XFF ;
				PORTC = 0X00 ;
			}

			else 

			{
				PORTE = 0X00 ;
				PORTC = 0XFF ;
			}



	if ( i_state == period )	i_state = 0 ;



	return ;



}

//----------------------------------END OF STATE_FIVE DEFINITION -----------------------------------------










//------------------------------------ STATE_SIX 	DEFINITION ---------------------------------------------



	void STATE_SIX()		// HEART BEAT (	VARIABLE DUTY )		INTERLEASED BLUE & RED

{


	period = 255 ;

	//	duty is variable

	i_state ++ ;

		if (	i_state <= duty)

			{
				PORTE = 0XFF ; 	//phase 1 HIGH 
				PORTC = 0X00 ; 	//phase 1 HIGH 

			}

			else 

			{
				PORTE = 0X00 ; 	//phase 1 LOW
				PORTC = 0XFF ; 	//phase 1 LOW

			}







	if ( i_state >= period )

		{

	i_state = 0 ;	 		// Reset counter for phase



	m_state++;




	if ( m_state >	3 )

{
	m_state = 0 ;

	if( duty <= 0 )
	{

	duty = 0 ;

	dimming = 0 ;

	glowing=1;

	}

	if ( duty >= period )

	{

	duty = period ;

	dimming=1;

	glowing=0;

	}




	if (	glowing == 1	)
	
	{
				duty++ ; 	//increase duty
	}

	if (	dimming==1	)

	{
				duty-- ; 	//decrease duty
	}		

}



		
		}  // end of period machine
	

	return ;

}



//----------------------------------END OF STATE_SIX DEFINITION -----------------------------------------








// ASSUMPTION :


//	 ACCELEROMETER Right  HORIZONTAL  --> 	OP > 2.5V


//	 ACCELEROMETER left  HORIZONTAL --> 	OP < 2.5V



